/* This routine assumes the following files are in the current Stata working directory: */
/* - NAT.shp */
/* - NAT.dbf */

/* Create row-standardized Queen weights matrix */
shp2dta using NAT, database(nat) coordinates(natxy) genid(ids) gencentroids(nat_c) replace
use nat
spmat contiguity w using natxy, norm(row) id(ids) replace

/* Table 2 - Spatial error model with exogenous variables and homoskedasticity (GM_Error_Hom): */
spivreg HR90 RD90 UE90, el(w) id(ids)

/* Table 3 - Spatial error model with endogenous variables and homoskedasticity (GM_Endog_Error_Hom): */
spivreg HR90 RD90 (UE90 = FP89), el(w) id(ids)

/* Table 4 - Combo model with homoskedasticity (GM_Combo_Hom): */
spivreg HR90 RD90 UE90, dl(w) el(w) id(ids)

/* Table 5 - Spatial error model with exogenous variables and heteroskedasticity (GM_Error_Het): */
spivreg HR90 RD90 UE90, el(w) id(ids) het

/* Table 6 - Spatial error model with endogenous variables and heteroskedasticity (GM_Endog_Error_Het): */
spivreg HR90 RD90 (UE90 = FP89), el(w) id(ids) het

/* Table 7 - Combo model with heteroskedasticity (GM_Combo_Het): */
spivreg HR90 RD90 UE90, el(w) dl(w) id(ids) het
